ogma-core-1.12.0: Ogma: Helper tool to interoperate between Copilot and other languages.

Safe Haskell | None
Language | Haskell2010

Command.CFSApp

Description

Create NASA Core Flight System (CFS) applications that subscribe to the communication bus and call Copilot when new messages arrive.

The applications are created ready to be extracted in the application directory in CFS, and they subscribe to a generic monitor. It is the user's responsibility to modify the generated Copilot and C code to deal with the monitors they'd like to implement, and the data they must manipulate.

Synopsis

- command :: CommandOptions -> IO (Result ErrorCode)
- data CommandOptions = CommandOptions {
  - commandConditionExpr :: Maybe String
  - commandInputFile :: Maybe FilePath
  - commandTargetDir :: FilePath
  - commandTemplateDir :: Maybe FilePath
  - commandVariables :: Maybe FilePath
  - commandVariableDB :: Maybe FilePath
  - commandHandlers :: Maybe FilePath
  - commandFormat :: String
  - commandPropFormat :: String
  - commandPropVia :: Maybe String
  - commandExtraVars :: Maybe FilePath
  }
- type ErrorCode = Int

# Documentation

command :: CommandOptions -> IO (Result ErrorCode) Source #

Generate a new CFS application connected to Copilot.

data CommandOptions Source #

Options used to customize the conversion of specifications to ROS applications.

Constructors

CommandOptions |

Fields

- commandConditionExpr :: Maybe String

  Trigger condition.

- commandInputFile :: Maybe FilePath

  Input specification file.

- commandTargetDir :: FilePath

  Target directory where the application should be created.

- commandTemplateDir :: Maybe FilePath

  Directory where the template is to be found.

- commandVariables :: Maybe FilePath

  File containing a list of variables to make available to Copilot.

- commandVariableDB :: Maybe FilePath

  File containing a list of known variables with their types and the message IDs they can be obtained from.

- commandHandlers :: Maybe FilePath

  File containing a list of handlers used in the Copilot specification. The handlers are assumed to receive no arguments.

- commandFormat :: String

  Format of the input file.

- commandPropFormat :: String

  Format used for input properties.

- commandPropVia :: Maybe String

  Use external command to pre-process system properties.

- commandExtraVars :: Maybe FilePath

  File containing additional variables to make available to the template.

type ErrorCode = Int Source #

Encoding of reasons why the command can fail.